InitScreens:
DEFINT a-z
DEF FNArraySize& = 3+INT(BobRight+16/16)*(BobBottom+1)*Depth
DIM DrawRect(3),ToolName$(7)
DIM bPlane(5), ctabsave%(32)
DIM red(32),green(32),blue(32):DIM gete(32)
DECLARE FUNCTION xOpen&  LIBRARY
DECLARE FUNCTION xRead&  LIBRARY
DECLARE FUNCTION xWrite& LIBRARY
DECLARE FUNCTION AllocMem&() LIBRARY
LIBRARY "dos.library"
LIBRARY "exec.library"
LIBRARY "graphics.library"
Depth=5
SCREEN 1,320,200,5,1
WINDOW 3,"",(0,5)-(311,90),16,1
LOCATE 1,27:PRINT"Pen   (1)"
LOCATE 2,27:PRINT"Point (2)"
LOCATE 3,27:PRINT"Line  (3)"
LOCATE 4,27:PRINT"Oval  (4)"
LOCATE 5,27:PRINT"Rect. (5)"
LOCATE 6,27:PRINT"Eraser(6)"
LOCATE 7,27:PRINT"Paint (7)"
LOCATE 11,10:PRINT"Mode: 1";
LOCATE 9,1:PRINT"A"
COLOR 0,1:PRINT"B";:COLOR 0,2:PRINT"C";
COLOR 0,3:PRINT"D";:COLOR 0,4:PRINT"E";
COLOR 0,5:PRINT"F";:COLOR 0,6:PRINT"G";
COLOR 0,7:PRINT"H";:COLOR 0,8:PRINT"I";
COLOR 0,9:PRINT"J";:COLOR 0,10:PRINT"K";
COLOR 0,11:PRINT"L";:COLOR 0,12:PRINT"M";
COLOR 0,13:PRINT"N";:COLOR 0,14:PRINT"O";
COLOR 0,15:PRINT"P";:COLOR 0,16:PRINT"Q";
COLOR 0,17:PRINT"R";:COLOR 0,18:PRINT"S";
COLOR 0,19:PRINT"T";:COLOR 0,20:PRINT"U";
COLOR 0,21:PRINT"V";:COLOR 0,22:PRINT"W";
COLOR 0,23:PRINT"X";:COLOR 0,24:PRINT"Y";
COLOR 0,25:PRINT"Z";:COLOR 0,26:PRINT"O";
COLOR 0,27:PRINT"1";:COLOR 0,28:PRINT"2";
COLOR 0,29:PRINT"3";:COLOR 0,30:PRINT"4";
COLOR 0,31:PRINT"5";:COLOR 1,0
LOCATE 10,2:PRINT"*";
SCREEN 2,320,190,5,1
WINDOW 2,"",(0,4)-(311,170),16,2
FOR n=0 TO 1:READ re:red(n)=re:READ gr green(n)=gr:READ bl:blue(n)=bl
PALETTE n,red(n)/15,green(n)/15,blue(n)/15
WINDOW OUTPUT 2: NEXT n
DATA 0,0,0,15,15,15
FOR n=2 TO 31
re=INT(RND(1)*15):gr=INT(RND(1)*15):bl=INT(RND(1)*15)
red(n)=re:green(n)=gr:blue(n)=bl
PALETTE n,re/15,gr/15,bl/15
WINDOW OUTPUT 3
PALETTE n,re/15,gr/15,bl/15
WINDOW OUTPUT 2
NEXT n
PRINT "Amiga-BASIC Graphic Editor"
GOSUB InitConstant
GOSUB InitFile
GOSUB InitMenu
GOTO startover

InitConstant:
ToolMode=1
CurrentColor=1
RETURN
InitFile:
maxColor=2^Depth-1
PlanePick=maxColor
RETURN
InitMenu:
MENU 1,0,1,"File":MENU 1,1,1,"New"
MENU 1,2,1,"Open ...":MENU 1,4,1,"Quit"
MENU 1,3,1,"Save as ...":MENU 2,0,1,"Tools"
MENU 3,0,1,"Palt":MENU 3,1,1,"make"
MENU 3,0,1,"palt1":MENU 3,1,1,"  A"
MENU 4,2,1,"  B":MENU 4,3,1,"  C"
MENU 4,4,1,"  D":MENU 4,5,1,"  E"
MENU 4,6,1,"  F":MENU 3,1,1,"  G"
MENU 4,8,1,"  H":MENU 4,9,1,"  I"
MENU 4,10,1,"  J":MENU 4,11,1,"  K"
MENU 4,12,1,"  L":MENU 4,13,1,"  M"
MENU 4,14,1,"  N":MENU 4,15,1,"  O"
MENU 4,16,1,"  P":MENU 5,0,1,"PALT3"
MENU 5,1,1,"  Q":MENU 5,2,1,"  R"
MENU 5,3,1,"  S":MENU 5,4,1,"  T"
MENU 5,5,1,"  U":MENU 5,6,1,"  V"
MENU 5,7,1,"  W":MENU 5,8,1,"  X"
MENU 5,9,1,"  Y":MENU 5,10,1,"  Z"
MENU 5,11,1,"  0":MENU 5,12,1,"  1"
MENU 5,13,1,"  2":MENU 5,14,1,"  3"
MENU 5,15,1,"  4":MENU 5,16,1,"  5"
ToolName$(1)="Pen":ToolName$(2)="point"
ToolName$(3)="Line":ToolName$(4)="Oval"
ToolName$(5)="Rectangle":ToolName$(6)="Eraser"
ToolName$(7)="Paint"
FOR i=1 TO 7:MENU 2,i,1,ToolName$(i):NEXT i
CLS:RETURN

startover:
ON MENU GOSUB CheckMenu : MENU ON
ON MOUSE GOSUB CheckMouse : MOUSE ON
ON BREAK GOSUB IgnoreBreak: BREAK ON
Unfinished = -1
WHILE Unfinished
SLEEP 
WEND

MENU OFF: MOUSE OFF
SCREEN CLOSE 2: SCREEN CLOSE 1
LIST:MENU RESET:CLS:END

CheckMenu:
MenuId=MENU(0)
menuitem=MENU(1)
ON MenuId GOTO FileMenu,ToolsMenu,mpalette,check1,check2
CheckMouse:
GetCurrentXY :StartY=CurrentY:StartX=CurrentX
ON ToolMode GOSUB Pen,Dpoint,DrawLine,DrawCircle,DrawRectangle,ErasePicture,PaintPicture
RETURN
ToolsMenu:
ToolMode=menuitem
WINDOW OUTPUT 3:LOCATE 11,15:PRINT menuitem;
WINDOW OUTPUT 2:RETURN
FileMenu:
ON menuitem GOSUB NewFile,OpenFile,SaveFileas,Quit
RETURN
IgnoreBreak: 
  RETURN

NewFile:
CLS
GOTO startover
Quit:
Unfinished=0
RETURN
OpenFile:
WINDOW 4,"OPEN",(10,80)-(301,90),16,1
INPUT ILBMname$:WINDOW CLOSE 4:WINDOW 2
IF ILBMname$="" THEN GOTO mcleanup
ccrtDir%=0:ccrtStart%=0:ccrtEnd%=0
ccrtSecs&=0:ccrtMics&=0
loadError$="":GOSUB LoadILBM
FOR kk=0 TO 31:nom=gete(kk)
red(kk)=INT(nom/256):nom=nom-(red(kk)*256)
green(kk)=INT(nom/16):nom=nom-(green(kk)*16)
blue(kk)=nom
IF red(kk)>7 AND red(kk)<15 THEN red(kk)=red(kk)-1
IF green(kk)>7 AND green(kk)<15 THEN green(kk)=green(kk)-1
IF blue(kk)>7 AND blue(kk)<15 THEN blue(kk)=blue(kk)-1
NEXT kk
GOT mcleanup
IF loadError$<>"" THEN GOTO mcleanup
IF foundCCRT AND ccrtDir% THEN FOR kk=0 TO nColors% -1
ctabsave%(kk) = PEEKW(colorTab&+(kk*2))
cTabWork%(kk)=ctabsave%(kk):NEXT
FOR kk=0 TO 80
IF ccrtDir%=1 THEN GOSUB Fcycle
ELSE
GOSUB Bcycle
END IF
CALL LoadRGB4&(sViewPort&, VARPTR(cTabWork%(0)),nColors%)
FOR de1=0 TO ccrtSecs&*3000
FOR de2=0 TO ccrtMics&/500
NEXT:NEXT:NEXT
CALL LoadRGB4&(sViewPort&,VARPTR(ctabsave%(0)),nColors%)
END IF
LoadILBM:
f$=ILBMname$:fHandle$=0:mybuf&=0
foundBMHD=0:foundCMAP=0:foundCAMG=0
foundCCRT=0:foundBODY=0
filename$=f$+CHR$(0)
fHandle&=xOpen&(SADD(filename$),1005)
IF fHandle&=0 THEN loadError$= "Can't open/find pic file"
GOTO Lcleanup
END IF
ClearPublic&= 65537&
mybufsize&= 360
mybuf& = AllocMem&(mybufsize&,ClearPublic&)
IF mybuf&= 0 THEN
loadError$ = "Can't alloc buffer"
GOTO Lcleanup
END IF
inbuf$ = mybuf&:cbuf& = mybuf&+120
ctab& = mybuf&+240
rLen&=xRead&(fHandle&,inbuf&,12)
tt$=""
FOR kk=8 TO 11
tt%=PEEK(inbuf%+kk):tt$=tt$+CHR$(tt%)
NEXT
IF tt$<>"ILBM" THEN loadError$="Not standard ILBM pic file"
GOTO Lcleanup
END IF
ChunkLoop:
rLen&=xRead&(fHandle&,inbuf&,8)
icLen&=PEEKL(inbuf&+4)
tt$=""
FOR kk=0 TO 3:tt%=PEEK(inbuf& + kk)
tt$=tt$+CHR$(tt%):NEXT
IF tt$="BMHD" THEN 'BitMap header
foundBMHD=1
rLen&=xRead&(fHandle&,inbuf&,icLen&)
iWidth%=PEEKW(inbuf&)
iHeight%=PEEKW(inbuf&+2)
iDepth%=PEEK(inbuf&+8)
iCompr%=PEEK(inbuf&+10)
scrWidth%=PEEKW(inbuf&+16)
scrHeight%=PEEKW(ibuf&+18)
iRowBytes%=iWidth/8
scrRowBytes%=scrWidth/8
nColors%=2^(iDepth%)
AvailRam&=FRE(-1)
NeededRam&=((scrWidth/8)*scrHeight*(iDepth%+1))+5000
IF AvailRam&<NeededRam& THEN loadError$="Not enough free ram"
GOTO Lcleanup
END IF
kk=1
IF scrWidth%>320 THEN kk=kk+1
IF scrHeight%>200 THEN kk=kk+2
GOSUB GetScrAddrs
ELSEIF tt$="CMAP" THEN 'ColorMap
foundCMAP=1
rLen&=xRead&(fHandle&,cbuf&,icLen&)
FOR kk=0 TO nColors%-1
red%=PEEK(cbuf&+(kk*3))
gre%=PEEK(cbuf&+(kk*3)+1)
red%=PEEK(cbuf&+(kk*3)+2)
regtemp%=(red%*16)+(gre%)+(blu%/16)
POKEW(ctab&+(2*kk)),regtemp%
gete(kk)=regtemp%:NEXT
ELSEIF tt$="CAMG" THEN 'Amiga ViewPort Modes"
foundCAMG=1
rLen&=xRead&(fHandle&,inbuf&,icLen&)
camgModes&=PEEKL(inbuf&)
ELSEIF tt$="CCRT" THEN 'Graphicraft color cycle info
foundccrt=1:rLen&=xRead&(fHandle&,inbuf&,icLen&)
ccrtDir%=PEEKW(inbuf&)
ccrtStart%=PEEK(inbuf&+2)
ccrtEnd%=PEEK(inbuf&+3)
ccrtSecs&=PEEKL(inbuf&+4)
ccrtMics&=PEEKL(inbuf&+8)
ELSEIF tt$="BODY" THEN 'BitMap
foundBODY=1
IF iCompr%=0 THEN 'no compression
FOR rr=0 TO iHeight% -1
FOR pp=0 TO iDepth% -1
scrRow& = bPlane&(pp)+(rr*scrRowBytes%)
rLen& = xRead&(fHandle&,scrRow&,iRowBytes%)
NEXT:NEXT
ELSEIF iCompr%=1 THEN 'cmpByteRun1
FOR rr=0 TO iHeight% -1
FOR pp=0 TO iDepth% -1
scrRow& = bPlane&(pp)+(rr*scrRowBytes%)
bCnt%=0
WHILE(bCnt% < iRowBytes%)
rLen& = xRead&(fHandle&,inbuf&,1)
inCode%=PEEK(inbuf&)
IF inCode%<128 THEN rLen&=xRead(fHandle&,scrRow&+bCnt%,inCode%+1)
ELSEIF inCode% > 128 THEN rLen&=xRead&(fHandle&,inbuf&,1)
inByte%=PEEK(inbuf&)
FOR kk=bCnt% TO bCnt%+257-inCode%
POKE(scrRow&+kk),inByte%:NEXT
bCnt%=bCnt%+257-inCode%
END IF
WEND
NEXT:NEXT
ELSE
loadError$="Unknown compression algorithm"
GOTO Lcleanup
END IF
ELSE
FOR kk=1 TO icLen&
rLen& = xRead&(fHandle&,inbuf&,1):NEXT
IF (icLen& OR 1)=icLen& THEN
rLen& = xRead&(fHandle&,inbuf&,1)
END IF
END IF
IF foundBMHD AND foundCMAP AND foundBODY
 THEN
GOTO GoodLoad
END IF
IF rLen&>0 THEN GOTO ChunkLoop
IF rLen&<0 THEN 'Read error
loadError$= "Read error"
GOTO Lcleanup
END IF
IF (foundBMHD=0) OR (foundBODY=0) OR (foundCMAP=0) THEN
loadError$="Needed ILBM chunks not found"
GOTO Lcleanup
END IF
GoodLoad:
loadError$=""
IF foundCMAP THEN CALL LoadRGB4&(sViewPort&,ctab&,nColors%)
END IF
Lcleanup:
IF fHandle& <> 0 THEN CALL xClose&(fHandle&)
IF mybuf& <> 0 THEN CALL FreeMem&(mybuf&,mybufsize&)
RETURN

SaveFileas:
WINDOW 4,"save",(10,80)-(301,90),16,1
INPUT ILBMname$
WINDOW CLOSE 4:WINDOW 2
IF ILBMname$="" THEN GOTO mcleanup
w=320: h=200: d=5
AvailRam&=FRE(-1)
NeededRam&=((w/8*h*(d+1))+5000
IF AvailRam&<NeededRam& THEN
GOTO Mcleanup2
END IF
t$=" SaveILBM"
GOSUB GetScrAddrs
ccrtDir%=1
ccrtStart%=1
ccrtEnd%=nColors%-1
ccrtSecs%=0
ccrtMics&=2000
FOR kk=0 TO nColors%-1
ctabsave%(kk)=PEEKW(colorTab&+(kk*2))

NEXT
deSecs&=ccrtSecs*3000
deMics&=ccrtMics&/500
cStart&=colorTab&+(2*ccrtStart%)
cEnd&=colorTab&+(2*ccrtEnd%)
repeat=80
CALL LoadRGB4&(sViewPort,VARPTR(ctabsave%(0)),nColors%)
IF(ILBmname$<>"") THEN
saveError$ = ""
GOSUB SaveILBM
END IF
mcleanup:
Mcleanup2:
WINDOW 3
FOR n=0 TO 31
PALETTE n,red(n)/15,green(n)/15,blue(n)/15
NEXT n
WINDOW 2
RETURN
SaveILBM:
f$ = ILBMname$
fHandle&=0
mybuf&=0
filename$=f$+CHR$(0)
fHandle&=xOpen&(SADD(filename$),1006)
IF fHandle&=0 THEN
saveError$="Can't open output file"
GOTO Scleanup
END IF
ClearPublic&=65537&
mybufsize&=120
mybuf&=AllocMem&(mybufsize&,ClearPublic&)
IF mybuf&=0 THEN
saveError$="Can't alloc buffer"
GOTO Scleanup
END IF
cbuf&=mybuf&
GOSUB GetScrAddrs
zero&=0
pad%=0
aspect%=&HA0B
BMHDsize&=20
CMAPsize&=(2^scrDepth%)*3
CAMGsize&=4
CCRTsize&=14
BODYsize&=(scrWidth%/8)*scrHeight%*scrDepth%
FORMsize&=BMHDsize&+CMAPsize&+CAMGsize&+CCRTsize&+BODYsize&+44
tt$="FORM"
wLen&=xWrite&(fHandle&,SADD(tt$),4)
wLen&=xWrite&(fHandle&,VARPTR(FORMsize&),4)
tt$="ILBM"
wLen&=xWrite&(fHandle&,SADD(tt$),4)
IF wLen&<=0 THEN
saveError$="Error writing FORM header"
GOTO Scleanup
END IF
tt$="BMHD"
wLen&=xWrite&(fHandle&,SADD(tt$),4)
wLen&=xWrite&(fHandle&,VARPTR(BMHDsize&),4)
wLen&=xWrite&(fHandle&,VARPTR(scrWidth%),2)
wLen&=xWrite&(fHandle&,VARPTR(scrHeight%),2)
wLen&=xWrite&(fHandle&,VARPTR(zero&),4)
temp%=(256*scrDepth%)
wLen&=xWrite&(fHandle&,VARPTR(temp%),2)
wLen&=xWrite&(fHandle&,VARPTR(zero&),4)
wLen&=xWrite&(fHandle&,VARPTR(aspect%),2)
wLen&=xWrite&(fHandle&,VARPTR(scrWidth%),2)
wLen&=xWrite&(fHandle&,VARPTR(scrHeight%),2)
IF wLen&<=0 THEN
saveError$="Error writing BMHD"
GOTO Scleanup
END IF
tt$="CMAP"
wLen&=xWrite&(fHandle&,SADD(tt$),4)
wLen&=xWrite&(fHandle&,VARPTR(CMAPsize&),4)
FOR kk=0 TO nColors%-1
regtemp%=PEEKW(colorTab&+(2*kk))
POKE(cubf&+(kk*3)),(regtemp% AND &HF00)/16
POKE(cubf&+(kk*3)+1),(regtemp% AND &HF0)
POKE(cubf&+(kk*3)+2),(regtemp% AND &HF)*16
NEXT
wLen&=xWrite&(fHandle&,cbuf&,CMAPsize&)
IF wLen&<=0 THEN
saveError$="Error writing CMAP"
GOTO Scleanup
END IF
tt$="CAMG"
wLen&=xWrite&(fHandle&,SADD(tt$),4)
wLen&=xWrite&(fHandle&,VARPTR(CAMGsize&),4)
vpModes&=PEEKW(sViewPort&+32)
wLen&=xWrite&(fHandle&,VARPTR(vpModes&),4)
IF wLen&<=0 THEN saveError$="Error writing CAMG"
GOTO Scleanup
END IF
tt$="CCRT"
wLen&=xWrite&(fHandle&,SADD(tt$),4)
wLen&=xWrite&(fHandle&,VARPTR(CCRTsize&),4)
wLen&=xWrite&(fHandle&,VARPTR(ccrtDir%),2)
temp%=(256*ccrtStart%)+ccrtEnd%
wLen&=xWrite&(fHandle&,VARPTR(temp$),2)
wLen&=xWrite&(fHandle&,VARPTR(ccrtSecs&),4)
wLen&=xWrite&(fHandle&,VARPTR(ccrtMics&),4)
wLen&=xWrite&(fHandle&,VARPTR(pad%),2)
IF wLen&<=0 THEN saveError$="Error writing CCRT"
GOTO Scleanup
END IF tt$="BODY"
wLen&=xWrite&(fHandle&,SADD(tt$),4)
WLen&=xWrite&(fHandle&,VARPTR(BODYsize&),4)
scrRowBytes%=scrWidth%/8
FOR rr=0 TO scrHeight%-1
FOR pp=0 TO scrDepth% -1
scrRow&=bPlane&(pp)+(rr*scrRowBytes%)
wLen&=xWrite&(fHandle&,scrRow&,scrRowBytes%)
IF wLen&<=0 THEN saveError$= "Error writing BODY"
GOTO Scleanup
END IF
NEXT:NEXT
saveError$=""
Scleanup:
IF fHandle&<>0 THEN CALL xClose&(fHandle&)
IF mybuf&<>0 THEN CALL FreeMem&(mybuf&,mybufsize&)
RETURN
GetScrAddrs:
sWindow&   = WINDOW(7)
sScreen&   = PEEKL(sWindow& + 46)
sViewPort& = sScreen& + 44
sRastPort& = sScreen& + 84
sColorMap& = PEEKL(sViewPort& + 4)
colorTab&  = PEEKL(sColorMap& + 4)
sBitMap&   = PEEKL(sRastPort& + 4)
scrWidth%  = PEEKW(sScreen& + 12)
scrHeight% = PEEKW(sScreen& + 14)
scrDepth%  = PEEK(sBitMap& + 5)
nColors%   = 2^scrDepth%
FOR kk=0 TO scrDepth%-1
bPlane&(kk)=PEEKL(sBitMap&+8+(kk*4))
NEXT 
RETURN

Pen:
GetCurrentXY
PSET(CurrentX,CurrentY),CurrentColor
WHILE MOUSE(0)<>0
GetCurrentXY
LINE - (CurrentX,CurrentY),CurrentColor
WEND
RETURN
Dpoint:
GetCurrentXY
PSET (CurrentX,CurrentY),CurrentColor
WHILE MOUSE(0)<>0
GetCurrentXY
PSET (CurrentX,CurrentY),CurrentColor
WEND
RETURN
DrawCircle:
GOSUB TrackRect
CenterX=(DrawRect(1)+DrawRect(3))/2
CenterY=(DrawRect(2)+DrawRect(0))/2
RadiusX=(DrawRect(3)+DrawRect(1))/2
RadiusY=(DrawRect(2)+DrawRect(0))/2
IF RadiusX=0 OR RadiusY=0 THEN RETURN
aspect!=ABS(RadiusY/RadiusX)
IF RadiusX<RadiusY THEN RadiusX=RadiusY
CIRCLE (CenterX,CenterY),RadiusX,CurrentColor,,,aspect!
RETURN
DrawRectangle:
GOSUB TrackRect
LINE (DrawRect(1),DrawRect(0))-(DrawRect(3),DrawRect(2)),CurrentColor,b
RETURN
ErasePicture
WHILE MOUSE(0)<>0
GetCurrentXY
LINE (CurrentX-5,CurrentY-3)-(CurrentX,CurrentY),1,bf
LINE (CurrentX-5,CurrentY-3)-(CurrentX,CurrentY),0,bf
WEND
RETURN
PaintPicture:
PAINT (CurrentX,CurrentY),CurrentColor
RETURN
DrawLine:
WHILE MOUSE(0)<>0
GetCureentXY
InvertVideo
LINE (StartX,StartY)-(CurrentX,CurrentY)
 'draw line
LINE (StartX,StartY)-(CurrentX,CurrentY)
 'erase line
normalvideo
WEND
LINE (StartX,StartY)-(CurrentX,Currenty),CurrentColor
RETURN
TrackRect:
WHILE MOUSE(0)<>0
GetCurrentXY
DrawRect(0)=StartY
DrawRect(1)=StartX
DrawRect(2)=CurrentY
DrawRect(3)=CurrentX
InvertVideo
FrameRect DrawRect() 'Draw it
FrameRect DrawRect() 'Erase it
normalvideo
WEND
IF CurrentY<StartY THEN DrawRect(0)=CurrentY: DrawRect(2)=StartY
IF CurrentY<StartX THEN DrawRect(1)=CurrentY: DrawRect(3)=StartX
RETURN

mpalette:
WINDOW 3: MOUSE OFF:MENU OFF:n=CurrentColor
x1=red(n)+3:x2=green(n)+3:x3=blue(n)+3
GOSUB placer
10 a$=INKEY$:IF a$="" THEN 10
IF a$=" " THEN
n=n+1
END IF
IF a$="w" THEN n=n-1
END IF
IF n=32 THEN n=0
IF n=-1 THEN n=31
IF a$="7" THEN
red(n)=red(n)-1
IF red(n)<0 THEN red(n)=0
END IF
IF a$="8" THEN
red(n)=red(n)+1
IF red(n)>15 THEN red(n)=15
END IF
IF a$="4" THEN 
green(n)=green(n)-1
IF green(n)<0 THEN green(n)=0
END IF
IF a$="5" THEN
green(n)=green(n)+1
IF green(n)>15 THEN green(n)=15
END IF
IF a$="1" THEN
blue(n)=blue(n)-1
IF blue(n)<0 THEN blue(n)=0
END IF
IF a$="2" THEN
blue(n)=blue(n)+1
IF blue(n)>15 THEN blue(n)=15
END IF
PALETTE n,red(n)/15,green(n)/15,blue(n)/15
WINDOW OUTPUT 2
PALETTE n,red(n)/15,green(n)/15,blue(n)/15
WINDOW OUTPUT 3
x1=red(n)+3:x2=green(n)+3:x3=blue(n)+3
GOSUB placer
IF a$="q" THEN
WINDOW 2: COLOR 1,0: MOUSE ON:MENU ON
COLOR 1,0:RETURN
END IF
GOTO 10

placer:
LOCATE 1,1:COLOR n,n:PRINT"    "
LOCATE 3,1:COLOR 1,0:PRINT"R:";:COLOR 1,1:PRINT"                "
COLOR 1,0:PRINT"G:";:COLOR 1,1:PRINT"                "
COLOR 1,0:PRINT"B:";:COLOR 1,1:PRINT"                "
COLOR 2,2
LOCATE 3,x1:PRINT" ";:LOCATE 4,X2:PRINT" ";
LOCATE 5,x3:PRINT" ";:COLOR 1,0: RETURN
check1:
WINDOW OUTPUT 3:LOCATE 10,CurrentColor+1
PRINT " ";:CurrentColor=menuitem-1
LOCATE 10,CurrentColor+1: PRINT"*";
WINDOW OUTPUT 2:RETURN
check2:
WINDOW OUTPUT 3:LOCATE 10,CurrentColor+1
PRINT " ";:CurrentColor=menuitem+15
LOCATE 10,CurrentColor+1:PRINT"*";
WINDOW OUTPUT 2:RETURN
SUB GetCurrentXY STATIC
SHARED CurrentX,CurrentY,InsideBob,BobRight,BobBottom
dummy=MOUSE(0)
CurrentX=MOUSE(1)
CurrentY=MOUSE(2)
InsideBob=-1
IF CurrentX>BobRight OR CurrentY>BobBottom THEN InsideBob=0
IF CurrentX<0 OR CurrentY<0 THEN InsideBob=0
END SUB
SUB InvertVideo STATIC
CALL SetDrMd&(WINDOW(8),3)
END SUB
SUB normalvideo STATIC
CALL SetDrMd&(WINDOW(8),1)
END SUB
SUB FrameRect(rect()) STATIC
LINE (rect(1),rect(0))-(rect(3),rect(0))
LINE (rect(3),rect(0))-(rect(3),rect(2))
LINE (rect(3),rect(2))-(rect(1),rect(2))
LINE (rect(1),rect(2))-(rect(1),rect(0))
END SUB
